// Light.cpp: implementation of the Light class.
//			This class stores the representation of a Light in 
//			our scene
//////////////////////////////////////////////////////////////////////

#include "Light.h"
#include <stdio.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Light::Light()
{
    intensity = 0.0;
    position.Set(0.0, 0.0, 0.0, 1.0);
    radius = 0.0f;
}

Light::~Light()
{
}

Light::Light(const double I, double x, double y, double z, double R)
{
    intensity = I;
    position.Set(x, y, z, 1.0);
    radius = R;
}

//////////////////////////////////////////////////////////////////////
// Light.h: Interface for the Light class.
//			This class simply allows the interface to add lights
//			to the scene 
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

LightList::LightList()
{
    NumLights = 0;
}

LightList::~LightList()
{
}

//////////////////////////////////////////////////////////////////////
// Add : adds a light to our scene if we have not exceeded MAX_LIGHTS
//////////////////////////////////////////////////////////////////////
void LightList::Add(const double I, double x, double y, double z, double R)
{
    if( NumLights + 1 < MAX_LIGHTS )
    {
        Lights[NumLights] = Light(I, x, y, z, R);
        NumLights++;
    }
    else
    {
        fprintf(stderr, "too many light\n");
    }
}

