// Light.h: Interface for the Light class.
//			This class stores the representation of the Light 
//			Class.
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LIGHT_H__01C0789C_C9BB_4893_870F_C2DD12A87BB8__INCLUDED_)
#define AFX_LIGHT_H__01C0789C_C9BB_4893_870F_C2DD12A87BB8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Vec4.hpp"

#define MAX_LIGHTS 10

class Light
{
public:
	// Light Representation
    double intensity;	// light intensity
    Vec4 position;		// position
	double radius;		// radius (for area lights)
						// *NOTE* RADIUS NOT IMPLEMENTED

	// Constructors & Destructor
    Light();
	Light(const double I, double x, double y, double z, double R);
	virtual ~Light();
};

//////////////////////////////////////////////////////////////////////
// Light.h: Interface for the Light class.
//			This class simply allows the interface to add lights
//			to the scene 
//////////////////////////////////////////////////////////////////////

class LightList
{
public:
    Light Lights[MAX_LIGHTS];	// array of maximum supported lights
    int NumLights;				// the number of lights in the scene

	// Constructors & Destructor
    LightList();
    ~LightList();

	// Method to add a light to the scene
    void Add(const double I, double x, double y, double z, double R);
};

#endif // !defined(AFX_LIGHT_H__01C0789C_C9BB_4893_870F_C2DD12A87BB8__INCLUDED_)

