// Polygon.h: Interface for the Polygon class.
//			 Parent Class: Object
//			 This class stores the representation of a Polygon object	
//			 and provides a method to intersect a ray with the polygon
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_POLYGON_H__7811AA92_2501_4EED_965A_A0F0D32E80F5__INCLUDED_)
#define AFX_POLYGON_H__7811AA92_2501_4EED_965A_A0F0D32E80F5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Object.h"

class Polygon : public Object 
{
public:
	// Representation of the polygon
	int N;		// number of vectices
	Vec4 *P;	// array of points

	// Constructors & Destructor
	Polygon();
	Polygon(const Polygon& poly);
	Polygon(const int n, const Vec4* p);
	virtual ~Polygon();

	// Set methods
	void Set(const Polygon& poly);
	void Set(const int n, const Vec4* p);

	// returns true if the passed in point is 
	// inside the polygon.
	bool PointIsInside(Vec4 pt);

	// Intersection Test
	virtual bool Intersect(Ray ray, HitObject& ho);
};

#endif // !defined(AFX_POLYGON_H__7811AA92_2501_4EED_965A_A0F0D32E80F5__INCLUDED_)

