// Ray.h: Interface for the Ray class.
//		  This class contains the represetation of a Ray.
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RAY_H__3D3A626E_575A_4CFB_B1D8_A8D01EA2F686__INCLUDED_)
#define AFX_RAY_H__3D3A626E_575A_4CFB_B1D8_A8D01EA2F686__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Vec3.hpp"
#include "Vec4.hpp"
#include "Matrix.h"

class Ray  
{
public:
	Vec4 v4Ori;		// Origin
	Vec3 v3Dir;		// Direction
	
	// Constructor & Destructor
	Ray();
	Ray(const Ray& ray);
	virtual ~Ray();
	
	// Set Method
	void Set(Vec4 P, Vec3 V);

	// returns true if the ray's direction is (0,0,0)
	bool NoRay() const;

	// method to transform the ray by using
	// the object's inverse transformation matrix
	Ray InverseTransRay(Matrix T);
};

#endif // !defined(AFX_RAY_H__3D3A626E_575A_4CFB_B1D8_A8D01EA2F686__INCLUDED_)

