// Sphere.h: Interface for the Sphere class.
//			 Parent Class: Object
//			 This class stores the representation of a Sphere object	
//			 and provides a method to intersect a ray with the sphere
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SPHERE_H__EDD42AA1_F39C_4ECF_984A_9301A0359E4D__INCLUDED_)
#define AFX_SPHERE_H__EDD42AA1_F39C_4ECF_984A_9301A0359E4D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Object.h"

class Sphere : public Object  
{
public:
	// Representation of a sphere
	Vec4  center;
	double radius;

	// Constructors & Destructor
    Sphere();
	Sphere(const Sphere& s);
	Sphere(double x, double y, double z, double rad);
	virtual ~Sphere();

	// Set Methods
	void Set(const Sphere& s);
	void Set(double x, double y, double z, double rad);

	// Intersection Test
	virtual bool Intersect(Ray ray, HitObject& ho);
};

#endif // !defined(AFX_SPHERE_H__EDD42AA1_F39C_4ECF_984A_9301A0359E4D__INCLUDED_)

